#include <stdio.h>                      // printf()
#include "..\types\types.h"             // Bit32 Bit16 Bit8



void hex_dump_long( void *start, Bit32 length )
{
    Bit32 *address;
    Bit32 count;
    Bit16 line;

    printf( "\ndumping 32-bit values starting at 0x%8.8lX, length 0x%8.8lX\n", start, length );

    for( address=(Bit32 *)start; length>15; address+=16,length-=16 )
    {
        printf( "%8.8lX  ", address );

        for( line=0; line<4; line++ )
        {
            printf( " %8.8lX", address[line] );
        }

        printf( "\n" );
    }
}



void hex_dump_char( void *start, Bit32 length, unsigned per_line=16 )
{
    Bit8 *address;
    Bit32 count;
    Bit16 line;

    printf( "\ndumping 8-bit values starting at 0x%8.8lX, length 0x%8.8lX, %d per line\n", start, length, per_line );

    for( address=(Bit8 *)start; length>15; address+=per_line,length-=per_line )
    {
        printf( "%8.8lX  ", address );

        for( line=0; line<per_line; line++ )
        {
            printf( " %2.2X", address[line] );
        }

        printf( "\n" );
    }
}



