/* 1000, Mon 15 Sep 97

   Header file for DOS implementation of CMU SNMP

   Copyright (C) 1992-1998 by Nevil Brownlee,
   ITSS Technology Development,  The University of Auckland */

/* $Log: ausnmp.h,v $
 *
 * Revision 1.2  1998/04/30 04:57:13  rtfm
 * Bug fixes, change copyright date
 *
 * Revision 1.1  1998/04/30 04:07:43  rtfm
 * Initial revision
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef EXTSNMP  /* Nevil, 29 Apr 97 */
extern int au_snmp_port;
#else
int au_snmp_port = 161;  /* Default = SNMP well-known port */
#endif

#ifndef _TYPES_H  /* From Joel's types\types.h */
typedef unsigned char Bit8;
typedef unsigned short Bit16;
typedef unsigned long Bit32;
#endif

#ifdef _AIX
#define _XOPEN_EXTENDED_SOURCE  /* Needed to get syslog defined properly */
#endif
#if defined(DOS)
#define LOG_DEBUG  7
#define LOG_INFO   6
#define LOG_ERR    3
#else
#include <syslog.h>
#endif
#ifdef _AIX
#undef _XOPEN_EXTENDED_SOURCE
#endif

void log_msg(int priority, int die, char *fmt, ...);
   /* Generalised error message handler.  Nevil, 9 Sep 98 */


#ifdef DOS

#ifndef NULL
#define NULL ((void *)0)
#endif

#define WORDS_BIGENDIAN  0
#define SIZEOF_LONG      4

#ifndef WTCP_U_DEFS
typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;
#endif

#include <string.h>
#include <stdlib.h>
#include <mem.h>

#ifdef __FLAT__  /* Flat 32-bit memory model */

#define far
#define huge
#define farfree free
#define farmalloc malloc
#define farmove(d,s,n)  memcpy((char *)d,(char *)s,n)
#define qcmp(d,s,n)     memcmp((char *)d,(char *)s,n)

#else  /* Large memory model */
#define farmove(d,s,n)  memcpy((char *)d,(char *)s,n)
#define qcmp(d,s,n)     memcmp((char *)d,(char *)s,n)
#endif

#if 0
/* On the PC we used to use the small memory model.  This means we
     had to use qmove instead of memmove, since qmoves's s,d are far
     pointers, which we needed to reach flows, etc in far memory */
void qmove(  /* wattcp\elib\qmove.asm  */
   unsigned char far *s, unsigned char far *d, unsigned int n);
int  qcmp(   /* wattcp\elib\qcmp.asm  */
   unsigned char far *s1, unsigned char far *s2, unsigned int n);
#endif

#else  /* Not DOS */

#ifndef SUNOS
#define farmove(d,s,n)  memmove((char *)d,(char *)s,n)
#else
#define farmove(d,s,n)  memcpy((char *)d,(char *)s,n)
#endif
#define qcmp(s,d,n)     memcmp((char *)s,(char *)d,n)

#define scpos(x,y)  /* Used in TESTING code */

#define far
#define huge
#define farfree free
#define farmalloc malloc
#include <sys/types.h>
#include <string.h>
#include <malloc.h>
#include <memory.h>

#endif




#ifdef __cplusplus
}           // end extern "C"
#endif
