#include "..\wattcp\copyrigh.h"
#include "..\wattcp\wattcp.h"
#include <mem.h>

/* note: in case you were wondering, _chk_socket()
 * returns 2 for unclosed TCP, 1 for UDP, 0 otherwise
 */

int sock_rbsize( tcp_Socket *s )
{
    switch( _chk_socket( s )) {
        case 0 : return( 0 );
        default: return( s->maxrdatalen );
    }
}

int sock_rbused( tcp_Socket *s )
{
    switch( _chk_socket( s )) {
        case 0 : return( 0 );
        default: return( s->rdatalen );
    }
}

int sock_rbleft( tcp_Socket *s )
{
    switch( _chk_socket( s )) {
        case 0 : return( 0 );
        default: return( s->maxrdatalen - s->rdatalen );
    }
}

int sock_tbsize( tcp_Socket *s )
{
    switch( _chk_socket( s )) {
        case 2 : return( s->maxsdatalen );
        default: return( 0 );
    }
}

int sock_tbused( tcp_Socket *s )
{
    switch( _chk_socket( s )) {
        case 2 : return( s->sdatalen );
        default: return( 0 );
    }
}

int sock_tbleft( tcp_Socket *s )
{
    switch( _chk_socket( s )) {
        case 2 : return( s->maxsdatalen - s->sdatalen );
        default: return( 0 );
    }
}

int sock_preread( sock_type *s, byte *dp, int len )
{
    int count;
    int up_to_end;

    if (_chk_socket( &s->tcp ) == 0)
        return 0;

    if ( (count = s->udp.rdatalen) < 1)    /* 0 : no data, -1 : error */
        return( count );

    if ( count > len ) count = len;

    up_to_end = s->udp.maxrdatalen - s->udp.rdataoffset;
    if (up_to_end < count ) {
        movmem( s->udp.rdata + s->udp.rdataoffset, dp, up_to_end );
        movmem( s->udp.rdata, dp+up_to_end, count-up_to_end );
    }
    else
        movmem( s->udp.rdata + s->udp.rdataoffset, dp, count );

    return( count );
}
